/******************************************************************************/
/* mem.c  -- see http://www.zeppoo.net                                        */
/*                                                                            */
/* The project zeppoo is (C) 2006 : contact@zeppoo.net                        */
/* This program is free software;                                             */
/* you can redistribute it and/or modify it under the terms of the GNU        */
/* General Public License as published by the Free Software Foundation;       */
/* Version 2. This guarantees your right to use, modify, and                  */
/* redistribute this software under certain conditions.                       */
/*                                                                            */
/* Source is provided to this software because we believe users have a        */
/* right to know exactly what a program is going to do before they run        */
/* it.                                                                        */
/*                                                                            */
/* This program is distributed in the hope that it will be                    */
/* useful, but WITHOUT ANY WARRANTY; without even the implied                 */
/* warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR                    */
/* PURPOSE. See the GNU General Public License for more details (             */
/* http://www.gnu.org/copyleft/gpl.html ).                                    */
/*                                                                            */
/******************************************************************************/

#define _LARGEFILE64_SOURCE

#include "zeppoo.h"

int openmem(){
	printf("Memory : /dev/mem\n");
	
	if((mem = open("/dev/mem", O_RDONLY)) == -1){
		perror("open mem");
		exit(-1);
	}

	if(valmmap){
		if((ptr = mmap (0, 200 * 1024 * 1024, PROT_READ, MAP_PRIVATE, mem, 0)) == MAP_FAILED){
			perror("mmap ");
			exit(-1);
		}
	}
	
	return 0;
}

int closemem(int fd){

	if(valmmap){
		if(munmap((void *)ptr, 100 * 1024 * 1024) == -1){
			perror("munmap ");
			exit(-1);
		}
	}

	close(mem);

	return 0;
}

int readmem(unsigned long offset, void *buf, int size){
	int rlen;

	if(valmmap){
		memcpy(buf, ptr+offset-PAGE_OFFSET, size);
	}
	else{	
		if(lseek64(mem, (off64_t) offset - PAGE_OFFSET, SEEK_SET) == -1){
			perror("mem lseek :");
			exit(-1);
		}

		if((rlen = read(mem, buf, size)) != size){
			perror("mem read :");
			exit(-1);
		}
	}
	
	return rlen;
}

int writemem(unsigned long offset, void *buf, int size){
	int wlen;
	
	if(valmmap){
		memcpy(buf, ptr+offset-PAGE_OFFSET, size);
	}
	else {
		if(lseek64(mem, (off64_t) offset - PAGE_OFFSET, SEEK_SET) == -1){
			perror("mem lseek :");
			exit(-1);
		}

		if((wlen = write(mem, buf, size)) != size){
			perror("mem write :");
			exit(-1);
		}
	}
	return wlen;
}

