/******************************************************************************/
/* version.c  -- see http://www.zeppoo.net                                    */
/*                                                                            */
/* The project zeppoo is (C) 2006 : contact@zeppoo.net                        */
/* This program is free software;                                             */
/* you can redistribute it and/or modify it under the terms of the GNU        */
/* General Public License as published by the Free Software Foundation;       */
/* Version 2. This guarantees your right to use, modify, and                  */
/* redistribute this software under certain conditions.                       */
/*                                                                            */
/* Source is provided to this software because we believe users have a        */
/* right to know exactly what a program is going to do before they run        */
/* it.                                                                        */
/*                                                                            */
/* This program is distributed in the hope that it will be                    */
/* useful, but WITHOUT ANY WARRANTY; without even the implied                 */
/* warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR                    */
/* PURPOSE. See the GNU General Public License for more details (             */
/* http://www.gnu.org/copyleft/gpl.html ).                                    */
/*                                                                            */
/******************************************************************************/

#include "zeppoo.h"

float deletedot(char *chaine, size_t size){
	int i,j;
	float vkern;
	char kernel[size];
	i = j = 0;

	if((strstr(chaine, "."))){
		while(chaine[i] != '.' && i < size){
			kernel[j] = chaine[i];
			j++;
			i++;
		}
		kernel[j] = '.';
		j++;
		while(chaine[i] != '\0' && i < size){
			if(chaine[i] != '.'){
				kernel[j] = chaine[i];
				j++;
			}
		
			i++;
		}
		kernel[j] = '\0';
		vkern = atof(kernel);
	}
	return vkern;
}	

void zeppoo_init_version(char *kernel, char *archi){
	if(kernel != NULL)
		zepversion.kernel = deletedot(kernel, strlen(kernel));
	else
		zepversion.kernel = 2.6;

	printf("Kernel : %.1f\n", zepversion.kernel);

	if(archi != NULL)
		memcpy(zepversion.archi, archi, sizeof(zepversion.archi));	
	else
		memcpy(zepversion.archi, "i386", sizeof(zepversion.archi));


	if(!strcmp(zepversion.archi, "amd64")){
		printf("Unsupported amd64\n");
		exit(-1);
	}
	else{
		printf("Running on i386 !!\n");
		zepversion.kernel_start = KERNEL_I386_START;
		zepversion.kernel_end = KERNEL_I386_END;
	}
}
