/******************************************************************************/
/* zeppoo.c  -- see http://www.zeppoo.net                                     */
/*                                                                            */
/* The project zeppoo is (C) 2006 : contact@zeppoo.net                        */
/* This program is free software;                                             */
/* you can redistribute it and/or modify it under the terms of the GNU        */
/* General Public License as published by the Free Software Foundation;       */
/* Version 2. This guarantees your right to use, modify, and                  */
/* redistribute this software under certain conditions.                       */
/*                                                                            */
/* Source is provided to this software because we believe users have a        */
/* right to know exactly what a program is going to do before they run        */
/* it.                                                                        */
/*                                                                            */
/* This program is distributed in the hope that it will be                    */
/* useful, but WITHOUT ANY WARRANTY; without even the implied                 */
/* warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR                    */
/* PURPOSE. See the GNU General Public License for more details (             */
/* http://www.gnu.org/copyleft/gpl.html ).                                    */
/*                                                                            */
/******************************************************************************/

#include "zeppoo.h"

void getOpcodes(unsigned long addr, unsigned long *tabopcodes){
	if(addr != 0){
		zeppoo_read_memory(addr, &tabopcodes[0], 4);
		zeppoo_read_memory(addr+4, &tabopcodes[1], 4);
	}
	else{
		tabopcodes[0] = tabopcodes[1] = 0;
	}
}

int resolve(char *file, unsigned long addr, char *name, int size){
	FILE *input;
	char line[80];
	char caddr[12];
	char *paddr, *pname, *end;

	bzero(name, size);
	bzero(caddr, sizeof(caddr));
	snprintf(caddr, sizeof(caddr) - 1, "0x%x", (unsigned int)addr);
	if((input = fopen(file, "r")) != NULL){
		while(fgets(line, 80, input) != NULL){
			paddr = strtok(line, " ");
			if(strstr(caddr, paddr)){
				pname = strtok(NULL, " ");
				pname = strtok(NULL, " ");
				end = strstr(pname, "\n");
				if(pname[0] != '_'){
					memcpy(name, pname, size - 1);
					name[end - pname] = '\0';
					fclose(input);
					return 0;
				}
			}

		}
		fclose(input);
	}
		
	memcpy(name, "UNKNOWN", size - 1);
	return -1;
}

int validAddr(unsigned long addr){
	if(addr > zepversion.kernel_start && addr < zepversion.kernel_end)
		return 0;
	else
		return -1;
}

void zeppoo_fatal(char *format, ...){
	va_list ap;
	va_start(ap, format);
	vfprintf(stderr, format, ap);
	fflush(stderr);
	va_end(ap);
	exit(-1);
}
